<template>
  <div>
    <h2>Gebouw aanpassen</h2>
    <div class="bg-white m-3 p-3 border-radius drop-shadow">
      <div class="row justify-content-center">
        <form @submit.prevent="onSubmit" class="col-lg-6">
          <div class="mb-3">
            <label for="name" class="h5 mb-1 required">Naam</label>
            <input
              class="form-control p-2"
              required
              v-model="fields.name"
              type="text"
            />
          </div>
          <div class="mb-3">
            <MapBox id="map" :location="location"></MapBox>
          </div>
          <div class="row">
            <div class="mb-3 col-6">
              <label for="adress" class="h5 mb-1 required">Adres</label>
              <input
                class="form-control p-2"
                required
                v-model="fields.address"
                type="text"
              />
              <p
                class="show"
                @click="geocode(fields.address, fields.city, fields.zip)"
              >
                Toon op kaart
              </p>
            </div>
            <div class="mb-3 col-6">
              <label for="round" class="h5 mb-1 required">Ronde</label>
              <select
                class="form-select"
                v-model="fields.round"
                aria-label="Default select example"
                type="number"
              >
                <option
                  v-for="round in rounds"
                  :value="round.id"
                  :key="round.id"
                >
                  {{ round.name }}
                </option>
              </select>
            </div>
          </div>
          <div class="row">
            <div class="mb-3 col-6">
              <label for="city" class="h5 mb-1">Stad</label>
              <input class="form-control p-2" v-model="fields.city" />
            </div>
            <div class="mb-3 col-6">
              <label for="zip" class="h5 mb-1">Postcode</label>
              <input class="form-control p-2" v-model="fields.zip" />
            </div>
          </div>
          <div class="row">
            <div class="mb-3 col-12">
              <label for="description" class="h5 mb-1">Beschrijving</label>
              <input class="form-control p-2" v-model="fields.description" />
            </div>
          </div>
          <label for="codes" class="h5 mb-3">Codes</label>
          <div
            :key="index"
            v-for="index in range(codesCount)"
            class="row justify-content-center"
          >
            <div class="mb-3 col-4">
              <label for="codes" class="h7 mb-1">Titel</label>
              <input class="form-control p-2" v-model="codeTitels[index]" />
            </div>
            <div class="mb-3 col">
              <label for="codes" class="h7 mb-1">Code</label>
              <input class="form-control p-2" v-model="codes[index]" />
            </div>
            <div class="col-11 underline"></div>
          </div>
          <div class="icon" @click="codesCount++">
            <Icon class="svg" icon="gala:add" />
          </div>
          <label for="instructions" class="h5 mb-3">Instructies</label>
          <div
            :key="index"
            v-for="index in range(instructionCount)"
            class="row justify-content-center"
          >
            <div class="mb-3 col-4">
              <label for="instructions" class="h7 mb-1">Titel</label>
              <input class="form-control p-2" v-model="titels[index]" />
            </div>
            <div class="mb-3 col">
              <label for="instructions" class="h7 mb-1">Instructie</label>
              <input class="form-control p-2" v-model="instructions[index]" />
            </div>
            <div class="col-11 underline"></div>
          </div>
          <div class="icon" @click="instructionCount++">
            <Icon class="svg" icon="gala:add" />
          </div>
          <div class="mb-3">
            <div
              class="error-text"
              v-for="(error, index) in this.errors"
              :key="index"
            >
              {{ error }}
            </div>
          </div>
          <button type="submit">Opslaan</button>
        </form>
      </div>
    </div>
  </div>
</template>

<script>
import MapBox from "./molecules/MapBox.vue";
import axios from "axios";
import { Icon } from "@iconify/vue";

export default {
  components: { MapBox, Icon },
  data() {
    return {
      submitting: false,
      fields: {},
      moreInfo: false,
      errors: [],
      hasErrors: false,
      rounds: [],
      location: {
        lon: 0,
        lat: 0,
      },
      instructions: [],
      codes: [],
      titels: [],
      codeTitels: [],
      instructionCount: 0,
      codesCount: 0,
    };
  },
  props: ["id"],
  created() {
    this.fetchBuilding();
  },
  methods: {
    range(n) {
      return Array.from({ length: n + 1 }, (_, index) => index);
    },
    onSubmit() {
      this.validateFields(this.fields);
      if (!this.hasErrors) {
        this.updateRound();
      }
    },
    convertInstructionsToString() {
      let instructionsString = "";
      this.titels.forEach((titel, index) => {
        instructionsString +=
          "{ 'title': '" +
          titel +
          "', 'body': '" +
          this.instructions[index] +
          "' },";
      });
      this.fields.instructions = instructionsString;
    },
    convertCodesToString() {
      let codesString = "";
      this.codeTitels.forEach((titel, index) => {
        codesString +=
          "{ 'title': '" + titel + "', 'body': '" + this.codes[index] + "' },";
      });
      this.fields.codes = codesString;
    },
    async updateRound() {
      this.convertCodesToString();
      this.convertInstructionsToString();
      const userData = {
        id: this.fields.id,
        name: this.fields.name,
        roundId: this.fields.round,
        address: this.fields.address,
        city: this.fields.city,
        zip: this.fields.zip,
        description: this.fields.description,
        lon: this.location.lon,
        lat: this.location.lat,
        instructionsString: this.fields.instructions,
        scheduleString: this.fields.scheduleString,
        image: this.fields.image,
        codes: this.fields.codes,
      };
      await axios
        .put(
          "/api/building",
          userData, // the data to post
          {
            withCredentials: true,
            headers: {
              "Access-Control-Allow-Origin": "*",
              "Content-Type": "application/json",
            },
          }
        )
        .then((response) => {
          console.log(response);
          this.$router.push({
            name: "BuildingsDetail",
            params: { id: this.fields.id },
          });
        });
    },
    validateFields(fields) {
      if (fields.round === "" || !fields.round) {
        this.hasErrors = true;
        this.errors[0] = "Geen ronde geselecteerd.";
      } else {
        this.hasErrors = false;
        this.errors.splice(0);
      }
    },
    async fetchRounds() {
      try {
        const response = await axios.get("/api/round");
        this.rounds = response.data;
      } catch (error) {
        console.error("Failed to fetch rounds:", error);
      }
    },
    fetchBuilding() {
      axios
        .get("/api/building/" + this.$route.params.id, {
          withCredentials: true,
          headers: {
            "Access-Control-Allow-Origin": "*",
            "Content-Type": "application/json",
          },
        })
        .then((response) => {
          this.fields = response.data;
          this.fields.round = response.data.round.id;
          this.location.lat = response.data.lat;
          this.location.lon = response.data.lon;
          this.fields.shedule = response.data.shedule;
          console.log(response);
          this.convertCodesFromString();
          this.convertInstructionsFromString();
        });
    },

    convertInstructionsFromString() {
      if (this.fields.instructionsString !== null) {
        var instructions = JSON.parse(
          "[" +
            this.fields.instructionsString.slice(0, -1).replace(/'/g, '"') +
            "]"
        );
        this.titels = instructions.map((o) => o.title);
        this.instructions = instructions.map((o) => o.body);
        this.instructionCount = this.instructions.length - 1;
      }
    },
    convertCodesFromString() {
      if (this.fields.codes !== null) {
        var codes = JSON.parse(
          "[" + this.fields.codes.slice(0, -1).replace(/'/g, '"') + "]"
        );
        this.codeTitels = codes.map((o) => o.title);
        this.codes = codes.map((o) => o.body);
        this.codesCount = this.codes.length - 1;
      }
    },
    geocode(address, city, zip) {
      console.log("converting");
      axios
        .get(
          "/api/building/geocode/" +
            address.replaceAll(" ", "+") +
            (city == null ? "" : "," + city.replaceAll(" ", "+")) +
            (zip == null ? "" : "," + zip.replaceAll(" ", "+"))
        )
        .then((response) => {
          var coordinateNumbers = response.data.replaceAll("[", "").split(",");
          this.location.lon = parseFloat(coordinateNumbers[0]);
          this.location.lat = parseFloat(coordinateNumbers[1]);
        });
    },
  },
  mounted() {
    this.fetchRounds(); // Fetch the rounds when the component is mounted
  },
  computed: {
    formData() {
      const fd = new FormData();
      Object.keys(this.fields).forEach((key) => {
        fd.append(key, this.fields[key]);
      });
      return fd;
    },
  },
};
</script>

<style lang="scss" scoped>
.error-text {
  color: red;
}

.show:hover {
  cursor: pointer;
}
label.required:after {
  content: " *";
  color: red;
}
#map {
  height: 12rem;
}
.icon {
  margin-bottom: 1.5rem;
  display: flex;
  justify-content: center;
  &:hover {
    cursor: pointer;
  }
}

.svg {
  transform: scale(1.5);
}

.underline {
  border-bottom: 1px solid var(--lightmedium-grey);
  margin-bottom: 1rem;
  margin-top: 0.5rem;
}
</style>
